# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####

bl_info = {
    "name": "Thea Render",
    "author": "Grzegorz Rakoczy",
    "version": (1,5,6,411,1434),
    "blender": (2, 7, 7),
    "location": "Render>Engine>Thea Render",
    "description": "Thea Render",
    "warning": "",
    "category": "Render"}


if "bpy" in locals():
    import imp
    imp.reload(thea_render_main)
    imp.reload(thea_operators)    
    imp.reload(thea_properties)
    imp.reload(thea_gui)
    imp.reload(thea_exporter)
    imp.reload(thea_IR)
    imp.reload(thea_globals)

else:
    import bpy
    from bpy.props import *
    from . import thea_operators    
    from . import thea_properties
    from . import thea_gui
    from . import thea_exporter
    from . import thea_globals
    from . import thea_IR
    from . import thea_globals    
    from bpy.app.handlers import persistent


@persistent
def load_pre_handler(arg):
    
    if bpy.context.scene.thea_ir_running:
        from . import thea_render_main
        print("Stopping IR...")
        port = bpy.context.scene.thea_SDKPort
        
        data = thea_render_main.sendSocketMsg('localhost', port, b'version')

        if data.find('v'):        
            message = b'message "./UI/Viewport/Theme/RW_PROG"' 
            data = thea_render_main.sendSocketMsg('localhost', port, message)
            message = b'message "exit"' 
            data = thea_render_main.sendSocketMsg('localhost', port, message)                



bpy.app.handlers.load_pre.append(load_pre_handler)
    

def register():

    Scene = bpy.types.Scene
    bpy.utils.register_module(__name__)
    
    
#     try:        
#         km = bpy.context.window_manager.keyconfigs.active.keymaps['3D View Generic']
#         kmi = km.keymap_items.new('thea.refresh_ir',value='PRESS',type='F5',ctrl=False,alt=False,shift=False,oskey=False)    
#         
#         km = bpy.context.window_manager.keyconfigs.active.keymaps['Window']
#         kmi = km.keymap_items.new('thea.quit_blender',value='PRESS',type='Q',ctrl=True,alt=False,shift=False,oskey=False)
#     except:
#         pass
    
def unregister():

    Scene = bpy.types.Scene
    bpy.utils.unregister_module(__name__)
    print("unregister")
    
if __name__ == "__main__":
    register()    
    
    
import atexit

@atexit.register
def exitRemoteDarkroom():
    print("Sending exit signals to RemoteDarkroom processes")
    port = getattr(bpy.context.scene, 'thea_SDKPort', 30000)
    data = thea_render_main.sendSocketMsg('localhost', port, b'exit')
    port = getattr(bpy.context.scene, 'thea_PreviewSDKPort', 30001)
    data = thea_render_main.sendSocketMsg('localhost', port, b'exit')
    
        